/**
 * 
 */
package puntti;

import java.io.PrintStream;

import testaus.ErilaisetArvonnat;


/**
 * |------------------------------------------------------------------------|
 * | Luokan nimi: Liike                                 | Avustajat:        |
 * |-------------------------------------------------------------------------
 * | Vastuualueet:                                      |                   |
 * |                                                    |                   |
 * | (- ei tiedä puntista mitään, eikä kättöliittymästä)|                   |
 * | - tietää liikkeen kentät( oteleveys, stoppi, suori-|                   |
 * | tusväline, syvyys)                                 |                   |
 * | - tarkistaa kenttien oikeellisuuden(syntaksin)     |                   |
 * | - osaa muuttaa 1|penkkipunnerrus|..| merkkijonon   |                   |
 * | liikkeen tiedoiksi.                                |                   |
 * | - osaa antaa merkkijonona i:n kentän tiedot        |                   |
 * | - osaa laittaa merkkijonon i:neksi kentäksi        |                   |
 * |-------------------------------------------------------------------------
 * 
 * @author laspa
 * @version 4.3.2025
 *
 */
public class Liike {
    
    private int lid = 0;
    private String liike = "";
    private String oteLeveys = "";
    private int stoppi = 0;
    private String syvyys = "";
    private String suoritusValine = "";
    
    private static int seuraavaLid = 1;
    
    
    /**
     * Alustaa liikkeiden tiedot tyhjiksi
     */
    public Liike(){
        //ei käytössä, sillä tiedot on jo alustettu
    }
    
    
    /**
     * Tulostetaan liikeen tiedot
     * @param out tietovirta johon tulostetaan
     */
    public void tulosta(PrintStream out) {
        out.println(String.format("%03d", lid, 3) + "  " + liike + " ");
        out.println("Oteleveys " + oteLeveys + " ");
        out.println("Stoppi " + stoppi + " s ");              
        out.print("Syvyys " + syvyys + " ");
        out.println("Suoritusväline " + suoritusValine + " ");

    }
    
    
    
    /**
     * Antaa liikkeelle suraavan liike id:n eli lid
     * @return liikkeen id:n
     * @example
     * <pre name="test">
     *   Liike kyykky1 = new Liike();
     *   kyykky1.getLid() === 0;
     *   kyykky1.lisaaLiike();
     *   Liike kyykky2 = new Liike();
     *   kyykky2.lisaaLiike();
     *   int n1 = kyykky1.getLid();
     *   int n2 = kyykky2.getLid();
     *   n1 === n2-1;
     * </pre>
     */
    public int lisaaLiike() {
        this.lid = seuraavaLid;
        seuraavaLid++;
        return this.lid;
    }
    
    
    /**
     * täyttää liikkeen tiedot
     */
    public void taytaKyykky() {
        liike = "Kyykky" + ErilaisetArvonnat.arvontaS(1,20);
        oteLeveys = ErilaisetArvonnat.arvontaL();
        stoppi = ErilaisetArvonnat.arvontaS(1,10);
        syvyys = "Syvä";
        suoritusValine = "Tanko";
    }
    
    
    /**
     * Palauttaa liikkeen liike id:n
     * @return liikkeen liike id:n
     */
    public int getLid() {
        return lid;
    }
    
    /**
     * @return liikkeen nimi
     */
    public String getNimi() {
        return this.liike;
    }
    
    

    /**
     * @param args ei käytössä
     */
    public static void main(String[] args) {
        Liike kyykky = new Liike();
        Liike kyykky2 = new Liike();
        
        kyykky.lisaaLiike();
        kyykky2.lisaaLiike();
        
        kyykky.tulosta(System.out);
        kyykky2.tulosta(System.out);
        
        kyykky.taytaKyykky();
        kyykky2.taytaKyykky();
        
        kyykky.tulosta(System.out);
        kyykky2.tulosta(System.out);
        
    
    }




}

