/**
 * 
 */
package puntti;

/**
 * |------------------------------------------------------------------------|
 * | Luokan nimi:  Puntti                               | Avustajat:        |
 * |-------------------------------------------------------------------------
 * | Vastuualueet:                                      |                   |
 * |                                                    | - Liikkeet        |
 * | - Huolehtii Liikkeet ja Tulokset -luokkien         | - Tulos           |
 * | välisestä yhteistyöstä ja välittää näitä tietoja   | - Liike           |
 * | pyydettäessä                                       | - Tulokset        |
 * | - lukee ja kirjoittaa kerhon tiedostoon pyytämällä |                   |
 * | apuja avustajiltaan                                |                   |
 * |-------------------------------------------------------------------------
 * 
 * @author laspa
 * @version 5.3.2025
 *
 */
public class Puntti {
    
    private Liikkeet liikkeet = new Liikkeet();
    
    
    /**
     * Palautaa punti nliikkeiden määrän
     * @return liikemäärän
     */
    public int getLiikkeita() {
        return liikkeet.getLkm();
    }

    
    /**
     * Lisätään uusi liike
     * @param liike lisättävä liike
     * @throws SailoException kun lisääminen ei onnistu
     */
    public void lisaa(Liike liike) throws SailoException {
        liikkeet.lisaa(liike);
    }
    
    
    /**
     * Palauttaa i:n liikkeen
     * @param i mones liike palautetaan
     * @return viite i:teen liikkeeseen
     * @throws IndexOutOfBoundsException jos i on epäsopiva
     */
    public Liike annaLiike(int i) {
        return liikkeet.anna(i);
    }

    /**
     * @param args ei käytössä
     */
    public static void main(String[] args) {
        Puntti puntti = new Puntti();
        
        Liike kyykky = new Liike();
        Liike kyykky2 = new Liike();
        
        kyykky.lisaaLiike();
        kyykky.taytaKyykky();
        
        kyykky2.lisaaLiike();
        kyykky2.taytaKyykky();
        
        
        try {
            puntti.lisaa(kyykky);
            puntti.lisaa(kyykky2);
            
        } catch (SailoException e) {
            System.err.println(e.getMessage());
            
        }
        
        
        for (int i = 0; i < puntti.getLiikkeita(); i++) {
            Liike liike = puntti.annaLiike(i);
            System.out.println("Liike indeksi " + i);
            liike.tulosta(System.out);
        }
    
    }

}
