package puntti;

import java.io.PrintStream;

import testaus.ErilaisetArvonnat;

/**
 * |------------------------------------------------------------------------|
 * | Luokan nimi: Tulos                                 | Avustajat:        |
 * |-------------------------------------------------------------------------
 * | Vastuualueet:                                      |                   |
 * |                                                    |                   |
 * | (- ei tiedä puntista mitään, eikä kättöliittymästä)|                   |
 * | - tietää tuloksen kentät(tulos, päivämäärä)        |                   |
 * |                                                    |                   |
 * | - tarkistaa kenttien oikeellisuuden(syntaksin)     |                   |
 * | - osaa muuttaa 1|100|12.12.2024 merkkijonon        |                   |
 * | liikkeen tiedoiksi.                                |                   |
 * | - osaa antaa merkkijonona i:n kentän tiedot        |                   |
 * | - osaa laittaa merkkijonon i:neksi kentäksi        |                   |
 * |-------------------------------------------------------------------------
 *
 * @author laspa
 * @version 11.3.2025
 *
 */
public class Tulos {
    
    private int id = 0;
    private int lid = 0;
    private int tulos = 0;
    private String paivamaara = "";
    
    private static int seuraavaId = 1;
    
    
    /**
     * Alustaa liikkeiden tiedot tyhjiksi
     */
    public Tulos(){
        //ei käytössä, sillä tiedot on jo alustettu
    }
    
    
    
    /**
     * Alustetaan liike halutun liikkeen tulos
     * @param lid liikken id:ee minkä tulos halutaan laittaa
     */
    public Tulos(int lid) {
        this.lid = lid;
    }
    
    
    /**
     * täyttää tuloksen tiedot
     * @param ide minkä liikkeen tuloksesta on kyse
     */
    public void taytaPenkkiTulos(int ide) {
        lid = ide;
        tulos = ErilaisetArvonnat.arvontaS(20,100);
        paivamaara = ErilaisetArvonnat.arvoPaiva();
    }
    
    
    
    /**
     * Tulostetaan liikeen tiedot
     * @param out tietovirta johon tulostetaan
     */
    public void tulosta(PrintStream out) {
        out.println(tulos + "kg" + " " + paivamaara);

    }
    
    
    
    /**
     * Antaa tulokselle suraavan id:n
     * @return tuloksen id:n
     * @example
     * <pre name="test">
     *   Tulos penkki = new Tulos();
     *   penkki.getid() === 0;
     *   penkki.lisaaTulos();
     *   Tulos penkki2 = new Tulos();
     *   penkki2.lisaaTulos();
     *   int n1 = penkki.getid();
     *   int n2 = penkki2.getid();
     *   n1 === n2-1;
     * </pre>
     */
    public int lisaaTulos() {
        this.id = seuraavaId;
        seuraavaId++;
        return this.id;
    }
    
    
    /**
     * palauttaa tuloksen oman id:n
     * @return tuloksen id:n
     */
    public int getId() {
        return this.id;
    }
    
    
    
    
    /**
     * Palauttaa liikkeen liike id:n mille liikkeelle tulos kuuluu
     * @return liikkeen lid:n 
     */
    public int getLid() {
        return lid;
    }
    
   
    
    

    /**
     * Testiohjelma Tulokselle
     * @param args ei käytössä
     */
    public static void main(String[] args) {
        Tulos tulos = new Tulos();
        tulos.taytaPenkkiTulos(2);
        tulos.tulosta(System.out);
    }






}
